<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="设备名称" prop="deviceName">
        <el-input v-model="queryParams.deviceName" placeholder="请输入设备名称" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="设备编号" prop="deviceNo">
        <el-input v-model="queryParams.deviceNo" placeholder="请输入设备编号" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['system:device:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate"
          v-hasPermi="['system:device:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete"
          v-hasPermi="['system:device:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport"
          v-hasPermi="['system:device:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="deviceList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="设备编号" align="center" prop="deviceNo" />
      <el-table-column label="设备类型" align="center" prop="deviceType" />
      <el-table-column label="设备名称" align="center" prop="deviceName" />
      <el-table-column label="连接类型" align="center" prop="connectionType" />
      <el-table-column label="设备状态" align="center" prop="status">
        <template #default="scope">
          {{ scope.row.status == 'ONLINE' ? '在线' : '离线' }}
        </template>
      </el-table-column>
      <el-table-column label="客户端设备" align="center" prop="client">
        <template #default="scope">
          {{ clientFilter(scope.row.client) }}
        </template>
      </el-table-column>
      <el-table-column label="ip" align="center" prop="ip" />
      <el-table-column label="端口" align="center" prop="port" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button type="text" icon="Edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['system:device:edit']">修改</el-button>
          <el-button type="text" icon="Edit" @click="showLogs(scope.row)"
            v-hasPermi="['system:device:list']">查看日志</el-button>
          <el-button type="text" icon="Edit" @click="debug(scope.row)"
            v-hasPermi="['system:device:list']">设备调试</el-button>
          <el-button type="text" icon="Delete" @click="handleDelete(scope.row)"
            v-hasPermi="['system:device:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <el-dialog title="设备日志" v-model="showLogDialog" width="1200px">

      <el-tabs v-model="activeName" @tab-click="handleClick">
        <DeviceLog :deviceNo="currentDeviceNo"></DeviceLog>
      </el-tabs>

      <span slot="footer" class="dialog-footer">
        <el-button @click="showLogDialog = false">取 消</el-button>
        <el-button type="primary" @click="showLogDialog = false">确 定</el-button>
      </span>
    </el-dialog>

    <el-dialog title="设备调试" v-model="debugDialog" width="1200px">
      <DebugConsole :deviceNo="currentDeviceNo"></DebugConsole>
      <span slot="footer" class="dialog-footer">
        <el-button @click="debugDialog = false">取 消</el-button>
        <el-button type="primary" @click="debugDialog = false">确 定</el-button>
      </span>
    </el-dialog>


    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize"
      @pagination="getList" />
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="deviceRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="设备编号" prop="deviceNo">
          <el-input v-model="form.deviceNo" placeholder="请输入设备编号" />
        </el-form-item>
        <el-form-item label="设备名称" prop="deviceName">
          <el-input v-model="form.deviceName" placeholder="请输入设备名称" />
        </el-form-item>
        <el-form-item label="客户端" prop="client">
          <el-select v-model="form.client" class="m-2" placeholder="Select">
            <el-option v-for="item in dicst['booleanDist']" :key="item.dictValue" :label="item.dictLabel"
              :value="item.dictValue" />
          </el-select>
        </el-form-item>
        <el-form-item label="ip" prop="ip">
          <el-input v-model="form.ip" placeholder="请输入ip" />
        </el-form-item>
        <el-form-item label="端口" prop="port">
          <el-input v-model="form.port" placeholder="请输入端口" />
        </el-form-item>
        <el-form-item label="连接类型" prop="connectionType">
          <el-select v-model="form.connectionType" class="m-2" placeholder="Select">
            <el-option v-for="item in dicst['connection_type']" :key="item.dictValue" :label="item.dictLabel"
              :value="item.dictValue" />
          </el-select>
        </el-form-item>
        <el-form-item label="主题" prop="topic" v-if="form.connectionType == 'MQTT'">
          <el-input v-model="form.topic" placeholder="请输入主题" />
        </el-form-item>
        <el-form-item label="心跳指令" prop="heartbeat">
          <el-input v-model="form.heartbeat" placeholder="请输入主题" />
        </el-form-item>
        <el-form-item label="开启心跳" prop="openHeartbeat">
          <el-select v-model="form.openHeartbeat" class="m-2" placeholder="Select">
            <el-option v-for="item in dicst['booleanDist']" :key="item.dictValue" :label="item.dictLabel"
              :value="item.dictValue" />
          </el-select>
        </el-form-item>
        <el-form-item label="开启设备" prop="enable">
          <el-select v-model="form.enable" class="m-2" placeholder="Select">
            <el-option v-for="item in dicst['booleanDist']" :key="item.dictValue" :label="item.dictLabel"
              :value="item.dictValue" />
          </el-select>
        </el-form-item>
        <el-form-item label="设备类型" prop="deviceType">
          <el-select v-model="form.deviceType" class="m-2" placeholder="Select">
            <el-option v-for="item in dicst['device_type']" :key="item.dictValue" :label="item.dictLabel"
              :value="item.dictValue" />
          </el-select>
        </el-form-item>

      </el-form>

      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
        </div>
      </template>
    </el-dialog>


  </div>
</template>

<script setup name="Device">
import { listDevice, getDevice, delDevice, addDevice, updateDevice } from "@/api/system/device";
import { getDicts } from "@/api/system/dict/data";
import DeviceLog from "./deviceLog.vue";
import DebugConsole from "./deviceDebugConsole.vue";

const { proxy } = getCurrentInstance();
const showLogDialog = ref(false);
const deviceList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const debugDialog = ref(false)
const total = ref(0);
const title = ref("");
const dicst = ref({})
const currentDeviceNo = ref('')
const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    deviceName: null,
    status: null,
    client: null,
    ip: null,
    port: null,
    connectionType: null,
    deviceType: null,
    deviceNo: null
  },
  rules: {
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询设备列表 */
function getList() {
  loading.value = true;
  listDevice(queryParams.value).then(response => {
    deviceList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

const clientFilter = (value) => {
  for (const item of dicst.value['booleanDist']) {
    if (item.dictValue == value) {
      return item.dictLabel
    }
  }
}


// 表单重置
function reset() {
  form.value = {
    deviceId: null,
    deviceName: null,
    status: "0",
    client: null,
    ip: null,
    port: null,
    connectionType: null,
    deviceType: null,
    deviceNo: null,
    topic: null,
    heartbeat: null,
    openHeartbeat: null,
    enable: null
  };
  proxy.resetForm("deviceRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.deviceId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加设备";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const deviceId = row.deviceId || ids.value
  getDevice(deviceId).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改设备";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["deviceRef"].validate(valid => {
    if (valid) {
      if (form.value.deviceId != null) {
        updateDevice(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addDevice(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const deviceIds = row.deviceId || ids.value;
  proxy.$modal.confirm('是否确认删除设备编号为"' + deviceIds + '"的数据项？').then(function () {
    return delDevice(deviceIds);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => { });
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('system/device/export', {
    ...queryParams.value
  }, `device_${new Date().getTime()}.xlsx`)
}


const findDists = () => {
  let dictTypes = ['connection_type', 'device_type']
  let array = []
  for (const item of dictTypes) {
    array.push(getDicts(item))
  }
  Promise.all(array).then(res => {
    for (let i = 0; i < dictTypes.length; i++) {
      dicst.value[dictTypes[i]] = res[i].data
    }
    dicst.value['booleanDist'] = [{
      dictValue: true,
      dictLabel: '是'
    }, {
      dictValue: false,
      dictLabel: '否'
    }]

    getList();

  })
}

const showLogs = (row) => {
  showLogDialog.value = true
  currentDeviceNo.value = row.deviceNo
}

const debug =(row)=>{
  debugDialog.value = true
  currentDeviceNo.value = row.deviceNo
}

findDists();

</script>
